// Declaration incl. headerfiler

#include <iostream.h>

#ifndef	BOOL
	#define	BOOL	int
	#define	FALSE	0
	#define	TRUE	1
#endif

class	CxTalListe
{
public:
	CxTalListe	(int NyTabSize);
	~CxTalListe	(void);
	void	SkrivTabel		(void);
	void	InsertLast		(int Tal);
	void	InsertFirst		(int Tal);
	void	InsertSort		(int Tal);
	void	InsertSort2		(int Tal);
	int		FindMin			(void);
	int		FindMax			(void);
	BOOL	TestValueSeq		(int TestTal);
	BOOL	TestValueBin		(int TestTal);

private:
	int		Antal;
	int		TabSize;
	int		*Taltab;
};

// Implementation

CxTalListe::CxTalListe	(int NyTabSize)
:	Antal(0), TabSize(NyTabSize), Taltab(NULL)
{
	Taltab = new int[TabSize];	// opret array og st pointer
}

CxTalListe::~CxTalListe	(void)
{
	if (Taltab)				// Taltab != NULL
		delete [] Taltab;		// slet tilknyttet array
}

void	CxTalListe::SkrivTabel		(void)
{
	cout << "Udskrift af tabel\n";
	for (int ElmNr(0); ElmNr < Antal; ++ElmNr)
		cout << "Element : " << ElmNr
			 << " har vrdien " << Taltab[ElmNr] << "\n";
}

void	CxTalListe::InsertLast		(int Tal)
{
	Taltab[Antal] = Tal;
	++Antal;
}

void	CxTalListe::InsertFirst		(int Tal)
{
	for (int ElmNr(Antal); ElmNr > 0; --ElmNr)
		Taltab[ElmNr] = Taltab[ElmNr-1];
	Taltab[0] = Tal;
	++Antal;
}

void	CxTalListe::InsertSort		(int Tal)
//	Find plads forfra
{
	int NyElmNr(0);
	while ((Taltab[NyElmNr] < Tal) && (NyElmNr < Antal))
		++NyElmNr;

	for (int FlytElmNr(Antal); FlytElmNr > NyElmNr; --FlytElmNr)
		Taltab[FlytElmNr] = Taltab[FlytElmNr-1];
	
	Taltab[NyElmNr] = Tal;
	++Antal;
}

void	CxTalListe::InsertSort2		(int Tal)
//	Find plads bagfra og flyt samtidig
{
	int NyElmNr(Antal);
	while ((Taltab[NyElmNr-1] > Tal) && (NyElmNr > 0))
	{
		Taltab[NyElmNr] = Taltab[NyElmNr-1];
		--NyElmNr;
	}
	Taltab[NyElmNr] = Tal;
	++Antal;
}

int		CxTalListe::FindMin			(void)
{
	// precondition:  Frste elm. (0) indeholder mindste vrdi
	return (Taltab[0]);
}

int		CxTalListe::FindMax			(void)
{
	// precondition:  Sidste elm. (Antal-1) indeholder strste vrdi
	return (Taltab[Antal-1]);
}

BOOL	CxTalListe::TestValueSeq	(int TestTal)
{
//	Lsning med sekventiel sgning i sorterede data
	int ElmNr(0);
	while ((Taltab[ElmNr] < TestTal) && (ElmNr < Antal))
		++ElmNr;
	if ((ElmNr < Antal) && (Taltab[ElmNr] == TestTal))	// fundet ?
		return (TRUE);
	else
		return (FALSE);
}

BOOL	CxTalListe::TestValueBin		(int TestTal)
{
//	Lsning med binr sgning
	int Midt(0);
	int Start(0);
	int Slut(Antal-1);

	while (Start < Slut)
	{
		Midt = (Start+Slut)/2;
		if (Taltab[Midt] < TestTal)
			Start = Midt + 1;
		else
			Slut = Midt;
	}
	if (Taltab[Slut] == TestTal)		// fundet ?
		return (TRUE);
	else
		return (FALSE);
}


void	Vent	(void);			// Declaration

void	Vent	(void)			// Implementering
{
	int	Dummy;
	cout << "\nTast et tal og retur for at fortstte :";
	cin >> Dummy;
}


int main (void)		// main - aftestning af klasse
{
	CxTalListe	TL(30);

	TL.InsertFirst(10);
	TL.InsertFirst(8);
	TL.InsertFirst(6);
	TL.InsertLast(12);
	TL.InsertLast(14);
	TL.InsertLast(16);
	TL.InsertSort(4);
	TL.InsertSort(9);
	TL.InsertSort(6);
	TL.InsertSort2(13);
	TL.InsertSort2(11);
	TL.InsertSort2(13);
	TL.InsertSort2(2);
	TL.SkrivTabel();

	cout << "Minimum er: " << TL.FindMin() << "\n";
	cout << "Maksimum er: " << TL.FindMax() << "\n";

	int TestTal;
	cout << "Indtast et testtal :";
	cin >> TestTal;

	if (TL.TestValueSeq(TestTal))
		cout << "Test Seq: Tallet " << TestTal << " er i tabellen\n";
	else
		cout << "Test Seq: Tallet " << TestTal << " er ikke i tabellen\n";

	if (TL.TestValueBin(TestTal))
		cout << "Test Bin: Tallet " << TestTal << " er i tabellen\n";
	else
		cout << "Test Bin: Tallet " << TestTal << " er ikke i tabellen\n";

	Vent();

	return (0);
}